/* ***********************************************************
 * This file was automatically generated on 2012-05-18.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for output of voltage between 0 and 5V
	/// </summary>
	public class BrickletAnalogOut : Device 
	{
		private static byte FUNCTION_SET_VOLTAGE = 1;
		private static byte FUNCTION_GET_VOLTAGE = 2;
		private static byte FUNCTION_SET_MODE = 3;
		private static byte FUNCTION_GET_MODE = 4;


		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletAnalogOut(string uid) : base(uid) 
		{
			this.expectedName = "Analog Out Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;

		}

		/// <summary>
		///  Sets the voltage in mV. The possible range is 0V to 5V (0-5000).
		///  Calling this function will set the mode to 0 (see `:func:SetMode`).
		///  
		///  The default value is 0 (with mode 1).
		/// </summary>
		public void SetVoltage(ushort voltage)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_VOLTAGE, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(voltage, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the voltage as set by <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/>.
		/// </summary>
		public ushort GetVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		/// <summary>
		///  Sets the mode of the analog value. Possible modes:
		///  
		///  * 0: Normal Mode (Analog value as set by <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/> is applied
		///  * 1: 1k Ohm resistor to ground
		///  * 2: 100k Ohm resistor to ground
		///  * 3: 500k Ohm resistor to ground
		///  
		///  Setting the mode to 0 will result in an output voltage of 0. You can jump
		///  to a higher output voltage directly by calling <see cref="Tinkerforge.BrickletAnalogOut.SetVoltage"/>.
		///  
		///  The default mode is 1.
		/// </summary>
		public void SetMode(byte mode)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_MODE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(mode, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the mode as set by <see cref="Tinkerforge.BrickletAnalogOut.SetMode"/>.
		/// </summary>
		public byte GetMode()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_MODE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_MODE, out answer);

			return LEConverter.ByteFrom(4, answer);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetVoltage(out ushort voltage)
		{
			voltage = GetVoltage();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetMode(out byte mode)
		{
			mode = GetMode();
		}
	}
}
