/* ***********************************************************
 * This file was automatically generated on 2012-05-18.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for controlling two relays
	/// </summary>
	public class BrickletDualRelay : Device 
	{
		private static byte FUNCTION_SET_STATE = 1;
		private static byte FUNCTION_GET_STATE = 2;


		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletDualRelay(string uid) : base(uid) 
		{
			this.expectedName = "Dual Relay Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;

		}

		/// <summary>
		///  Sets the state of the relays, *true* means on and *false* means off. 
		///  For example: (true, false) turns relay 1 on and relay 2 off.
		///  
		///  If you just want to set one of the relays and don't know the current state
		///  of the other relay, you can get the state with <see cref="Tinkerforge.BrickletDualRelay.GetState"/>.
		///  
		///  The default value is (false, false).
		/// </summary>
		public void SetState(bool relay1, bool relay2)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_STATE, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(relay1, 4, data_);
			LEConverter.To(relay2, 5, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the state of the relays, *true* means on and *false* means off.
		/// </summary>
		public void GetState(out bool relay1, out bool relay2)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_STATE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_STATE, out answer);

			relay1 = LEConverter.BoolFrom(4, answer);
			relay2 = LEConverter.BoolFrom(5, answer);
		}
	}
}
