/* ***********************************************************
 * This file was automatically generated on 2012-05-18.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Dual-Axis Joystick with Button
	/// </summary>
	public class BrickletJoystick : Device 
	{
		private static byte FUNCTION_GET_POSITION = 1;
		private static byte FUNCTION_IS_PRESSED = 2;
		private static byte FUNCTION_GET_ANALOG_VALUE = 3;
		private static byte FUNCTION_CALIBRATE = 4;
		private static byte FUNCTION_SET_POSITION_CALLBACK_PERIOD = 5;
		private static byte FUNCTION_GET_POSITION_CALLBACK_PERIOD = 6;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;
		private static byte FUNCTION_SET_POSITION_CALLBACK_THRESHOLD = 9;
		private static byte FUNCTION_GET_POSITION_CALLBACK_THRESHOLD = 10;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;
		private static byte FUNCTION_SET_DEBOUNCE_PERIOD = 13;
		private static byte FUNCTION_GET_DEBOUNCE_PERIOD = 14;
		private static byte CALLBACK_POSITION = 15;
		private static byte CALLBACK_ANALOG_VALUE = 16;
		private static byte CALLBACK_POSITION_REACHED = 17;
		private static byte CALLBACK_ANALOG_VALUE_REACHED = 18;
		private static byte CALLBACK_PRESSED = 19;
		private static byte CALLBACK_RELEASED = 20;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackPeriod"/>. The parameter is the position of the
		///  Joystick.
		///  
		///  <see cref="Tinkerforge.BrickletJoystick.Position"/> is only triggered if the position has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Position(short x, short y);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackPeriod"/>. The parameters are the analog values
		///  of the Joystick.
		///  
		///  <see cref="Tinkerforge.BrickletJoystick.AnalogValue"/> is only triggered if the value has changed since the
		///  last triggering.
		/// </summary>
		public delegate void AnalogValue(ushort x, ushort y);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackThreshold"/> is reached.
		///  The parameters are the position of the Joystick.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletJoystick.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void PositionReached(short x, short y);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameters are the analog values of the Joystick.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletJoystick.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void AnalogValueReached(ushort x, ushort y);

		/// <summary>
		///  This callback is triggered when the button is pressed.
		/// </summary>
		public delegate void Pressed();

		/// <summary>
		///  This callback is triggered when the button is released.
		/// </summary>
		public delegate void Released();

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletJoystick(string uid) : base(uid) 
		{
			this.expectedName = "Joystick Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_POSITION] = new MessageCallback(CallbackPosition);
			messageCallbacks[CALLBACK_ANALOG_VALUE] = new MessageCallback(CallbackAnalogValue);
			messageCallbacks[CALLBACK_POSITION_REACHED] = new MessageCallback(CallbackPositionReached);
			messageCallbacks[CALLBACK_ANALOG_VALUE_REACHED] = new MessageCallback(CallbackAnalogValueReached);
			messageCallbacks[CALLBACK_PRESSED] = new MessageCallback(CallbackPressed);
			messageCallbacks[CALLBACK_RELEASED] = new MessageCallback(CallbackReleased);
		}

		/// <summary>
		///  Returns the position of the Joystick. The value ranges between -100 and
		///  100 for both axis. The middle position of the joystick is x=0, y=0. The
		///  returned values are averaged and calibrated (see <see cref="Tinkerforge.BrickletJoystick.Calibrate"/>).
		///  
		///  If you want to get the position periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletJoystick.Position"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackPeriod"/>.
		/// </summary>
		public void GetPosition(out short x, out short y)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POSITION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_POSITION, out answer);

			x = LEConverter.ShortFrom(4, answer);
			y = LEConverter.ShortFrom(6, answer);
		}

		/// <summary>
		///  Returns true if the button is pressed and false otherwise.
		///  
		///  It is recommended to use the <see cref="Tinkerforge.BrickletJoystick.Pressed"/> and <see cref="Tinkerforge.BrickletJoystick.Released"/> callbacks
		///  to handle the button.
		/// </summary>
		public bool IsPressed()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_IS_PRESSED, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_IS_PRESSED, out answer);

			return LEConverter.BoolFrom(4, answer);
		}

		/// <summary>
		///  Returns the values as read by a 12 bit analog to digital converter.
		///  The values are between 0 and 4095 for both axis.
		///  
		///  <note>
		///    The values returned by <see cref="Tinkerforge.BrickletJoystick.GetPosition"/> are averaged over several samples
		///    to yield less noise, while <see cref="Tinkerforge.BrickletJoystick.GetAnalogValue"/> gives back raw
		///    unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletJoystick.GetAnalogValue"/> is,
		///    if you need the full resolution of the analog to digital converter.
		///  </note>
		///  
		///  If you want the analog values periodically, it is recommended to use the 
		///  callback <see cref="Tinkerforge.BrickletJoystick.AnalogValue"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public void GetAnalogValue(out ushort x, out ushort y)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_ANALOG_VALUE, out answer);

			x = LEConverter.UShortFrom(4, answer);
			y = LEConverter.UShortFrom(6, answer);
		}

		/// <summary>
		///  Calibrates the middle position of the Joystick. If your Joystick Bricklet
		///  does not return x=0 and y=0 in the middle position, call this function
		///  while the Joystick is standing still in the middle position.
		///  
		///  The resulting calibration will be saved on the EEPROM of the Joystick
		///  Bricklet, thus you only have to calibrate it once.
		/// </summary>
		public void Calibrate()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_CALIBRATE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletJoystick.Position"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletJoystick.Position"/> is only triggered if the position has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetPositionCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_POSITION_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackPeriod"/>.
		/// </summary>
		public uint GetPositionCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POSITION_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_POSITION_CALLBACK_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletJoystick.AnalogValue"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletJoystick.AnalogValue"/> is only triggered if the analog value has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public uint GetAnalogValueCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletJoystick.PositionReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   :header: "Option", "Description"
		///   :widths: 10, 100
		///   "'x'", "Callback is turned off."
		///   "'o'", "Callback is triggered when the position is *outside* the min and max values"
		///   "'i'", "Callback is triggered when the position is *inside* the min and max values"
		///   "'&lt;'", "Callback is triggered when the position is smaller than the min value (max is ignored)"
		///   "'&gt;'", "Callback is triggered when the position is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0, 0, 0).
		/// </summary>
		public void SetPositionCallbackThreshold(char option, short minX, short maxX, short minY, short maxY)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_POSITION_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(minX, 5, data_);
			LEConverter.To(maxX, 7, data_);
			LEConverter.To(minY, 9, data_);
			LEConverter.To(maxY, 11, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackThreshold"/>.
		/// </summary>
		public void GetPositionCallbackThreshold(out char option, out short minX, out short maxX, out short minY, out short maxY)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			minX = LEConverter.ShortFrom(5, answer);
			maxX = LEConverter.ShortFrom(7, answer);
			minY = LEConverter.ShortFrom(9, answer);
			maxY = LEConverter.ShortFrom(11, answer);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletJoystick.AnalogValueReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   :header: "Option", "Description"
		///   :widths: 10, 100
		///   "'x'", "Callback is turned off."
		///   "'o'", "Callback is triggered when the position is *outside* the min and max values"
		///   "'i'", "Callback is triggered when the position is *inside* the min and max values"
		///   "'&lt;'", "Callback is triggered when the position is smaller than the min value (max is ignored)"
		///   "'&gt;'", "Callback is triggered when the position is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0, 0, 0).
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, ushort minX, ushort maxX, ushort minY, ushort maxY)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(minX, 5, data_);
			LEConverter.To(maxX, 7, data_);
			LEConverter.To(minY, 9, data_);
			LEConverter.To(maxY, 11, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out ushort minX, out ushort maxX, out ushort minY, out ushort maxY)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			minX = LEConverter.UShortFrom(5, answer);
			maxX = LEConverter.UShortFrom(7, answer);
			minY = LEConverter.UShortFrom(9, answer);
			maxY = LEConverter.UShortFrom(11, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///   <see cref="Tinkerforge.BrickletJoystick.PositionReached"/>, <see cref="Tinkerforge.BrickletJoystick.AnalogValueReached"/>
		///  
		///  are triggered, if the thresholds
		///  
		///   <see cref="Tinkerforge.BrickletJoystick.SetPositionCallbackThreshold"/>, <see cref="Tinkerforge.BrickletJoystick.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletJoystick.SetDebouncePeriod"/>.
		/// </summary>
		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void IsPressed(out bool pressed)
		{
			pressed = IsPressed();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetPositionCallbackPeriod(out uint period)
		{
			period = GetPositionCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValueCallbackPeriod(out uint period)
		{
			period = GetAnalogValueCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		internal int CallbackPosition(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);

			((Position)callbacks[CALLBACK_POSITION])(x, y);
			return 8;
		}

		internal int CallbackAnalogValue(byte[] data_)
		{
			ushort x = LEConverter.UShortFrom(4, data_);
			ushort y = LEConverter.UShortFrom(6, data_);

			((AnalogValue)callbacks[CALLBACK_ANALOG_VALUE])(x, y);
			return 8;
		}

		internal int CallbackPositionReached(byte[] data_)
		{
			short x = LEConverter.ShortFrom(4, data_);
			short y = LEConverter.ShortFrom(6, data_);

			((PositionReached)callbacks[CALLBACK_POSITION_REACHED])(x, y);
			return 8;
		}

		internal int CallbackAnalogValueReached(byte[] data_)
		{
			ushort x = LEConverter.UShortFrom(4, data_);
			ushort y = LEConverter.UShortFrom(6, data_);

			((AnalogValueReached)callbacks[CALLBACK_ANALOG_VALUE_REACHED])(x, y);
			return 8;
		}

		internal int CallbackPressed(byte[] data_)
		{
			((Pressed)callbacks[CALLBACK_PRESSED])();
			return 4;
		}

		internal int CallbackReleased(byte[] data_)
		{
			((Released)callbacks[CALLBACK_RELEASED])();
			return 4;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Position))
			{
				callbacks[CALLBACK_POSITION] = d;
			}
			else if(d.GetType() == typeof(AnalogValue))
			{
				callbacks[CALLBACK_ANALOG_VALUE] = d;
			}
			else if(d.GetType() == typeof(PositionReached))
			{
				callbacks[CALLBACK_POSITION_REACHED] = d;
			}
			else if(d.GetType() == typeof(AnalogValueReached))
			{
				callbacks[CALLBACK_ANALOG_VALUE_REACHED] = d;
			}
			else if(d.GetType() == typeof(Pressed))
			{
				callbacks[CALLBACK_PRESSED] = d;
			}
			else if(d.GetType() == typeof(Released))
			{
				callbacks[CALLBACK_RELEASED] = d;
			}
		}
	}
}
