/* ***********************************************************
 * This file was automatically generated on 2012-05-18.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for sensing Voltages between 0 and 50V
	/// </summary>
	public class BrickletVoltage : Device 
	{
		private static byte FUNCTION_GET_VOLTAGE = 1;
		private static byte FUNCTION_GET_ANALOG_VALUE = 2;
		private static byte FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = 3;
		private static byte FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = 4;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;
		private static byte FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = 7;
		private static byte FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = 8;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;
		private static byte FUNCTION_SET_DEBOUNCE_PERIOD = 11;
		private static byte FUNCTION_GET_DEBOUNCE_PERIOD = 12;
		private static byte CALLBACK_VOLTAGE = 13;
		private static byte CALLBACK_ANALOG_VALUE = 14;
		private static byte CALLBACK_VOLTAGE_REACHED = 15;
		private static byte CALLBACK_ANALOG_VALUE_REACHED = 16;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletVoltage.SetVoltageCallbackPeriod"/>. The parameter is the voltage of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletVoltage.Voltage"/> is only triggered if the voltage has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Voltage(ushort voltage);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletVoltage.SetAnalogValueCallbackPeriod"/>. The parameter is the analog value of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletVoltage.AnalogValue"/> is only triggered if the voltage has changed since the
		///  last triggering.
		/// </summary>
		public delegate void AnalogValue(ushort value);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletVoltage.SetVoltageCallbackThreshold"/> is reached.
		///  The parameter is the voltage of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletVoltage.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void VoltageReached(ushort voltage);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletVoltage.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameter is the analog value of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletVoltage.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void AnalogValueReached(ushort value);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletVoltage(string uid) : base(uid) 
		{
			this.expectedName = "Voltage Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_VOLTAGE] = new MessageCallback(CallbackVoltage);
			messageCallbacks[CALLBACK_ANALOG_VALUE] = new MessageCallback(CallbackAnalogValue);
			messageCallbacks[CALLBACK_VOLTAGE_REACHED] = new MessageCallback(CallbackVoltageReached);
			messageCallbacks[CALLBACK_ANALOG_VALUE_REACHED] = new MessageCallback(CallbackAnalogValueReached);
		}

		/// <summary>
		///  Returns the voltage of the sensor. The value is in mV and
		///  between 0mV and 50000mV.
		///  
		///  If you want to get the voltage periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletVoltage.Voltage"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletVoltage.SetVoltageCallbackPeriod"/>.
		/// </summary>
		public ushort GetVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_VOLTAGE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		/// <summary>
		///  Returns the value as read by a 12 bit analog to digital converter.
		///  The value is between 0 and 4095.
		///  
		///  <note>
		///    The value returned by <see cref="Tinkerforge.BrickletVoltage.GetVoltage"/> is averaged over several samples
		///    to yield less noise, while <see cref="Tinkerforge.BrickletVoltage.GetAnalogValue"/> gives back raw
		///    unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletVoltage.GetAnalogValue"/> is,
		///    if you need the full resolution of the analog to digital converter.
		///  </note>
		///  
		///  If you want the analog value periodically, it is recommended to use the 
		///  callback <see cref="Tinkerforge.BrickletVoltage.AnalogValue"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletVoltage.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public ushort GetAnalogValue()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_ANALOG_VALUE, out answer);

			return LEConverter.UShortFrom(4, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletVoltage.Voltage"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletVoltage.Voltage"/> is only triggered if the voltage has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetVoltageCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletVoltage.SetVoltageCallbackPeriod"/>.
		/// </summary>
		public uint GetVoltageCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletVoltage.AnalogValue"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletVoltage.AnalogValue"/> is only triggered if the analog value has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletVoltage.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public uint GetAnalogValueCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletVoltage.VoltageReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   :header: "Option", "Description"
		///   :widths: 10, 100
		///   "'x'", "Callback is turned off."
		///   "'o'", "Callback is triggered when the voltage is *outside* the min and max values"
		///   "'i'", "Callback is triggered when the voltage is *inside* the min and max values"
		///   "'&lt;'", "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
		///   "'&gt;'", "Callback is triggered when the voltage is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetVoltageCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletVoltage.SetVoltageCallbackThreshold"/>.
		/// </summary>
		public void GetVoltageCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			min = LEConverter.ShortFrom(5, answer);
			max = LEConverter.ShortFrom(7, answer);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletVoltage.AnalogValueReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   :header: "Option", "Description"
		///   :widths: 10, 100
		///   "'x'", "Callback is turned off."
		///   "'o'", "Callback is triggered when the voltage is *outside* the min and max values"
		///   "'i'", "Callback is triggered when the voltage is *inside* the min and max values"
		///   "'&lt;'", "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
		///   "'&gt;'", "Callback is triggered when the voltage is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, ushort min, ushort max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletVoltage.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out ushort min, out ushort max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, out answer);

			option = LEConverter.CharFrom(4, answer);
			min = LEConverter.UShortFrom(5, answer);
			max = LEConverter.UShortFrom(7, answer);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///   <see cref="Tinkerforge.BrickletVoltage.VoltageReached"/>, <see cref="Tinkerforge.BrickletVoltage.AnalogValueReached"/>
		///  
		///  are triggered, if the thresholds
		///  
		///   <see cref="Tinkerforge.BrickletVoltage.SetVoltageCallbackThreshold"/>, <see cref="Tinkerforge.BrickletVoltage.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			sendOneWayMessage(data_);
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletVoltage.SetDebouncePeriod"/>.
		/// </summary>
		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] answer;
			sendReturningMessage(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out answer);

			return LEConverter.UIntFrom(4, answer);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetVoltage(out ushort voltage)
		{
			voltage = GetVoltage();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValue(out ushort value)
		{
			value = GetAnalogValue();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetVoltageCallbackPeriod(out uint period)
		{
			period = GetVoltageCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValueCallbackPeriod(out uint period)
		{
			period = GetAnalogValueCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		internal int CallbackVoltage(byte[] data_)
		{
			ushort voltage = LEConverter.UShortFrom(4, data_);

			((Voltage)callbacks[CALLBACK_VOLTAGE])(voltage);
			return 6;
		}

		internal int CallbackAnalogValue(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValue)callbacks[CALLBACK_ANALOG_VALUE])(value);
			return 6;
		}

		internal int CallbackVoltageReached(byte[] data_)
		{
			ushort voltage = LEConverter.UShortFrom(4, data_);

			((VoltageReached)callbacks[CALLBACK_VOLTAGE_REACHED])(voltage);
			return 6;
		}

		internal int CallbackAnalogValueReached(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValueReached)callbacks[CALLBACK_ANALOG_VALUE_REACHED])(value);
			return 6;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Voltage))
			{
				callbacks[CALLBACK_VOLTAGE] = d;
			}
			else if(d.GetType() == typeof(AnalogValue))
			{
				callbacks[CALLBACK_ANALOG_VALUE] = d;
			}
			else if(d.GetType() == typeof(VoltageReached))
			{
				callbacks[CALLBACK_VOLTAGE_REACHED] = d;
			}
			else if(d.GetType() == typeof(AnalogValueReached))
			{
				callbacks[CALLBACK_ANALOG_VALUE_REACHED] = d;
			}
		}
	}
}
